<template>
  <crud-data-table-update
    :item="value"
    @onSave="onSave(value)"
    @emitTheValueBeforeEditOnClose="emitValueToParent"
  >
    {{ value | formatDate | symbolWhenEmpty }}
    <template v-slot:dialog>
      <v-form
        ref="form"
        @submit.prevent
      >
        <v-container
          fluid
          class="py-0 px-0 pb-3"
        >
          <v-row>
            <v-col>
              <raw-date-picker-single-field
                :value="value"
                class="mt-3"
                :min="minDate"
                :max="maxDate"
                @input="emitValueToParent"
              />
            </v-col>
          </v-row>
          <v-row>
            <v-col>
              <clear-selected-date-btn
                small
                @click="emitValueToParent(null)"
              />
            </v-col>
          </v-row>
        </v-container>
      </v-form>
    </template>
  </crud-data-table-update>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import UtilsMixin from '@/mixins/utils'

  export default {
    name: 'EditDueDateDialog',
    mixins: [DatesMixin, UtilsMixin],
    inheritAttrs: false,
    props: {
      value: String,
      itemId: {
        type: Number,
        required: true,
      },
      minDate: {
        type: String,
        required: true,
      },
      maxDate: {
        type: String,
        required: true,
      },
    },
    methods: {
      onSave (paymentReceivedAt) {
        if (this.$refs.form.validate()) {
          this.$store.dispatch('incomeAmounts/updateIncomeAmountPaymentReceivedAt', {
            ID: this.itemId,
            paymentReceivedAt,
          })
            .then(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('updateSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('updateError'),
              })
            })
        }
      },
      emitValueToParent (event) {
        this.$emit('input', event)
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          updateSuccess: 'Data de pagamento atualizada com sucesso!',
          updateError: 'Ops... Algo deu errado ao tentar atualizar a data de pagamento. Por favor, tente novamente.',
        },
        'en-US': {
          updateSuccess: 'Received date successfully updated!',
          updateError: 'Oops... Something went wrong while trying to update the received date. Please try again.',
        },
      },
    },
  }
</script>
